diff --git a/app/test/test_cryptodev_aes_test_vectors.h b/app/test/test_cryptodev_aes_test_vectors.h
index 08ae09390..df338756f 100644
--- a/app/test/test_cryptodev_aes_test_vectors.h
+++ b/app/test/test_cryptodev_aes_test_vectors.h
@@ -5,6 +5,15 @@
 #ifndef TEST_CRYPTODEV_AES_TEST_VECTORS_H_
 #define TEST_CRYPTODEV_AES_TEST_VECTORS_H_
 
+#ifdef RTE_LIBRTE_PMD_AESNI_MB
+#include <intel-ipsec-mb.h>
+#endif
+
+#if !defined(IMB_VERSION_NUM)
+#define IMB_VERSION(a, b, c) (((a) << 16) + ((b) << 8) + (c))
+#define IMB_VERSION_NUM IMB_VERSION(0, 49, 0)
+#endif
+
 /* test vectors */
 static const uint8_t plaintext_aes128ctr[] = {
 	0x6B, 0xC1, 0xBE, 0xE2, 0x2E, 0x40, 0x9F, 0x96,
@@ -2739,79 +2748,151 @@ static const struct blockcipher_test_case aes_docsis_test_cases[] = {
 		.test_descr = "AES-256-DOCSIS-BPI Full Block Encryption",
 		.test_data = &aes_test_data_docsis_4,
 		.op_mask = BLOCKCIPHER_TEST_OP_ENCRYPT,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI Runt Block Encryption",
 		.test_data = &aes_test_data_docsis_5,
 		.op_mask = BLOCKCIPHER_TEST_OP_ENCRYPT,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI Uneven Encryption",
 		.test_data = &aes_test_data_docsis_6,
 		.op_mask = BLOCKCIPHER_TEST_OP_ENCRYPT,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI Full Block Decryption",
 		.test_data = &aes_test_data_docsis_4,
 		.op_mask = BLOCKCIPHER_TEST_OP_DECRYPT,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI Runt Block Decryption",
 		.test_data = &aes_test_data_docsis_5,
 		.op_mask = BLOCKCIPHER_TEST_OP_DECRYPT,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI Uneven Decryption",
 		.test_data = &aes_test_data_docsis_6,
 		.op_mask = BLOCKCIPHER_TEST_OP_DECRYPT,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI OOP Full Block Encryption",
 		.test_data = &aes_test_data_docsis_4,
 		.op_mask = BLOCKCIPHER_TEST_OP_ENCRYPT,
 		.feature_mask = BLOCKCIPHER_TEST_FEATURE_OOP,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI OOP Runt Block Encryption",
 		.test_data = &aes_test_data_docsis_5,
 		.op_mask = BLOCKCIPHER_TEST_OP_ENCRYPT,
 		.feature_mask = BLOCKCIPHER_TEST_FEATURE_OOP,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI OOP Uneven Block Encryption",
 		.test_data = &aes_test_data_docsis_6,
 		.op_mask = BLOCKCIPHER_TEST_OP_ENCRYPT,
 		.feature_mask = BLOCKCIPHER_TEST_FEATURE_OOP,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI OOP Full Block Decryption",
 		.test_data = &aes_test_data_docsis_4,
 		.op_mask = BLOCKCIPHER_TEST_OP_DECRYPT,
 		.feature_mask = BLOCKCIPHER_TEST_FEATURE_OOP,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI OOP Runt Block Decryption",
 		.test_data = &aes_test_data_docsis_5,
 		.op_mask = BLOCKCIPHER_TEST_OP_DECRYPT,
 		.feature_mask = BLOCKCIPHER_TEST_FEATURE_OOP,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 	{
 		.test_descr = "AES-256-DOCSIS-BPI OOP Uneven Block Decryption",
 		.test_data = &aes_test_data_docsis_6,
 		.op_mask = BLOCKCIPHER_TEST_OP_DECRYPT,
 		.feature_mask = BLOCKCIPHER_TEST_FEATURE_OOP,
+#if IMB_VERSION_NUM >= IMB_VERSION(0, 53, 3)
+		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT |
+			BLOCKCIPHER_TEST_TARGET_PMD_MB
+#else
+
 		.pmd_mask = BLOCKCIPHER_TEST_TARGET_PMD_QAT
+#endif
 	},
 };
 #endif /* TEST_CRYPTODEV_AES_TEST_VECTORS_H_ */